datablock AudioProfile(WrestlingRaiseSound)
{
	filename = "./raise.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(WrestlingPushSound)
{
	filename = "./push.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(WrestlingSwooshSound)
{
	filename = "./swoosh.wav";
	description = AudioClosest3d;
	preload = true;
};
datablock AudioProfile(WrestlingHitSound1)
{
	filename = "./genhit1.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(WrestlingHitSound2)
{
	filename = "./genhit2.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ItemData(WrestlingBeltItem)
{
	// shapeFile = "./wrestlingbelt.dts";
	shapeFile = "base/data/shapes/brickweapon.dts";

	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;

	uiName = "Wrestling Belt";
	// iconName = "./Icon_WrestlingBelt";
	doColorShift = true;
	colorShiftColor = "1 1 0 1";

	image = WrestlingBeltImage;

	canDrop = true;
};

datablock ShapeBaseImageData(WrestlingBeltImage)
{
	className = "WeaponImage";
	// shapeFile = "./wrestlingbelt.dts";
	shapeFile = "base/data/shapes/empty.dts";

	mountPoint = 0;

	item = WrestlingBeltItem;
	armReady = false;

	doColorShift = WrestlingBeltItem.doColorShift;
	colorShiftColor = WrestlingBeltItem.colorShiftColor;
};

datablock ShapeBaseImageData(WrestlingBeltAccesoryImage)
{
	className = "WeaponImage";
	// shapeFile = "./wrestlingbelt.dts";
	shapeFile = "base/data/shapes/brickweapon.dts";

	offset = "0 0.3 -0.9";
	eyeOffset = "0 -2 -1";
	rotation = eulerToMatrix("90 0 90");

	mountPoint = 2;

	doColorShift = WrestlingBeltItem.doColorShift;
	colorShiftColor = WrestlingBeltItem.colorShiftColor;
};

function WrestlingBeltImage::onMount(%this, %obj, %slot)
{
	Parent::onMount(%this, %obj, %slot);
	fixArmReady(%obj);
	%obj.mountImage(WrestlingBeltAccesoryImage, 2);
}
function WrestlingBeltImage::onUnMount(%this, %obj, %slot)
{
	%obj.unMountImage(2);
	Parent::onUnMount(%this, %obj, %slot);
}

function Player::WrestlingBackBreaker(%obj)
{
	if(!isObject(%obj.heldPlayer)) return;
	%target = %obj.heldPlayer;
	%obj.playThread(1, "walk");
	%obj.schedule(200, playThread, 1, "root");
	%obj.playThread(2, "plant");
	%obj.playThread(3, "plant");
	serverPlay3d(WrestlingHitSound @ getRandom(1, 2), %target.getHackPosition());
	%target.playThread(2, "plant");
	%target.damage(%obj, %target.getHackPosition(), 40, $DamageType::Direct);
	%obj.mountObject(%target, 8);
	%target.dismount();
	%origin = %obj.getPosition();
	%position = vectorAdd(%origin, vectorScale(%obj.getForwardVector(), 2));
	%ray = containerRayCast(%origin, %position, $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticShapeObjectType); //No stuckination in bricks or terrain pls
	%velocity = vectorScale(%obj.getForwardVector(), 10);
	if (%ray !$= 0) {
		%position = %origin;
		%velocity = "0 0 0";
	}
	%target.setVelocity(%velocity);
	%target.setTransform(%position SPC getWords(%obj.getTransform(), 3, 6));
	%obj.nextWrestlingCooldown = 1000;
	%obj.lastWrestlingAction = getSimTime();
}

function Player::WrestlingGroundSlam(%obj)
{
	if(!isObject(%obj.heldPlayer)) return;
	%target = %obj.heldPlayer;
	%obj.playThread(1, "shiftDown");
	%obj.playThread(2, "plant");
	%obj.playThread(3, "plant");
	serverPlay3d(WrestlingHitSound @ getRandom(1, 2), %target.getHackPosition());
	%target.playThread(1, "death1");
	%target.schedule(300, playThread, 1, "root");
	%target.playThread(2, "plant");
	%target.damage(%obj, %target.getHackPosition(), 35, $DamageType::Direct);
	%obj.mountObject(%target, 8);
	%target.dismount();
	%origin = %obj.getPosition();
	%position = vectorAdd(%origin, "0 0 -3");
	%ray = containerRayCast(%origin, %position, $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticShapeObjectType); //No stuckination in bricks or terrain pls
	%velocity = "0 0 -10";
	if (%ray !$= 0) {
		%position = %origin;
		%velocity = "0 0 0";
	}
	%target.setVelocity(%velocity);
	%target.setTransform(%position SPC getWords(%obj.getTransform(), 3, 6));
	%obj.setVelocity("0 0 10");
	%obj.nextWrestlingCooldown = 1000;
	%obj.lastWrestlingAction = getSimTime();
}

function Player::WrestlingSuplex(%obj)
{
	if(!isObject(%obj.heldPlayer)) return;
	%target = %obj.heldPlayer;
	%obj.playThread(1, "death1");
	%obj.schedule(300, playThread, 1, "root");
	%obj.playThread(2, "jump");
	%obj.playThread(3, "jump");
	serverPlay3d(WrestlingHitSound @ getRandom(1, 2), %target.getHackPosition());
	%target.playThread(1, "death1");
	%target.schedule(300, playThread, 1, "root");
	%target.playThread(2, "plant");
	%target.damage(%obj, %target.getHackPosition(), 35, $DamageType::Direct);
	%obj.mountObject(%target, 8);
	%target.dismount();
	%origin = %obj.getPosition();
	%position = vectorSub(%origin, vectorScale(%obj.getForwardVector(), 2));
	%ray = containerRayCast(%origin, %position, $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticShapeObjectType); //No stuckination in bricks or terrain pls
	%velocity = "0 0 -5";
	if (%ray !$= 0) {
		%position = %origin;
		%velocity = "0 0 0";
	}
	%target.setVelocity(vectorScale(%obj.getForwardVector(), -10));
	%target.setTransform(%position SPC getWords(%obj.getTransform(), 3, 6));
	%obj.setVelocity(vectorScale(%obj.getForwardVector(), 4));
	%obj.nextWrestlingCooldown = 1000;
	%obj.lastWrestlingAction = getSimTime();
}

function Player::grabDoAfter(%this, %target, %ticks)
{
	cancel(%this.grabDoAfter);
	if (%ticks $= "")
		%ticks = 1;

	%a = %this.getEyePoint();
	%b = vectorAdd(%a, vectorScale(%this.getEyeVector(), 4));
	%mask = $TypeMasks::All ^ $TypeMasks::FxBrickAlwaysObjectType;

	%ray = containerRayCast(%a, %b, %mask, %this);
	if (%ray != %target || %this.getMountedImage(0) != WrestlingBeltImage.getID() || !isObject(%target))
	{
		if (isObject(%this.client))
			%this.client.centerPrint("Grab failed!", 2);
		return -1; //Fail
	}
	%dot = vectorDot(%this.getForwardVector(), %target.getForwardVector());
	if (%ticks > 3 || %dot > 0)
	{
		if (isObject(%this.client))
			%this.client.centerPrint("\c3Grab success!", 2);
		if (isObject(%target.heldPlayer))
			%target.heldPlayer.dismount();
		%this.heldPlayer = %target;
		%this.mountObject(%target, 0);
		%this.playThread(2, "ArmReadyBoth");
		%target.playThread(0, "death1");
		%target.setLookLimits(0.5,0.5);
		%target.setTransform("0 0 -100 0 0 -1 -1.5709");
		%this.nextWrestlingCooldown = 400;
		%this.lastWrestlingAction = getSimTime();
		serverPlay3d(WrestlingRaiseSound, %ray.getHackPosition());
		return 1; //Success
	}
	%this.playThread(2, "shiftRight");
	for (%i = 0; %i < %ticks % 4; %i++)
	{
		%dots = %dots @ ".";
	}
	%this.client.centerPrint("\c6Grabbing" @ %dots, 2);
	%this.grabDoAfter = %this.schedule(100, grabDoAfter, %target, %ticks++); //400 ms to grab
}

function Player::escapeDoAfter(%this, %ticks)
{
	cancel(%this.escapeDoAfter);
	if (%ticks $= "")
		%ticks = 1;

	if (!isObject(%mount = %this.getObjectMount()))
	{
		if (isObject(%this.client))
			%this.client.centerPrint("Escape failed!", 2);
		return -1; //Fail
	}
	if (%ticks > 3)
	{
		if (isObject(%this.client))
			%this.client.centerPrint("\c3Escape success!", 2);
		%this.getObjectMount().mountObject(%this, 8);
		%this.dismount();
		return 1; //Success
	}
	for (%i = 0; %i < %ticks % 4; %i++)
	{
		%dots = %dots @ ".";
	}
	%this.client.centerPrint("\c6Escaping" @ %dots, 2);
	%this.escapeDoAfter = %this.schedule(75, escapeDoAfter, %ticks++); //300 ms to escape
}

package WrestlingBeltPackage
{
	function Armor::onMount(%this, %obj, %mount, %slot)
	{
		Parent::onMount(%this, %obj, %mount, %slot);
		if (!isObject(%mount.heldPlayer))
			return;
		if (isObject(%client = %obj.client) && isObject(%client.camera))
		{
			%client.camera.setOrbitMode(%mount, %mount.getTransform(), 0.5, 8, 8, 1);
			%client.setControlObject(%client.camera);
			%client.isSpectator = false;
		}
	}
	function Armor::onUnMount(%this, %obj, %mount, %slot)
	{
		Parent::onUnMount(%this, %obj, %mount, %slot);
		if (!isObject(%mount.heldPlayer) || %mount.heldPlayer != %obj)
			return;
		if (isObject(%client = %obj.client) && isObject(%client.camera))
		{
			%client.camera.setControlObject(%client);
			%client.setControlObject(%obj);
		}
		%mount.heldPlayer = "";
		%obj.setLookLimits(1,0);
		%obj.playThread(0, "root");
	}
	function Observer::onTrigger(%this, %obj, %slot, %state)
	{
		%client = %obj.getControllingClient();
		if (isObject(%player = %client.player))
		{
			if (isObject(%mount = %player.getObjectMount()) && %mount.heldPlayer == %player) //Escaping grabs
			{
				if (%slot == 4)
				{
					if (%state)
					{
						%player.escapeDoAfter();
					}
					else
					{
						if (isEventPending(%player.escapeDoAfter))
						{
							if (isObject(%player.client))
								%player.client.centerPrint("Escape failed!", 2);
							cancel(%player.escapeDoAfter);
						}
					}
				}
			}
		}
		return parent::onTrigger(%this, %obj, %slot, %state);
	}
	function Armor::onTrigger(%this, %obj, %slot, %state)
	{
		Parent::onTrigger(%this, %obj, %slot, %state);
		if (%obj.getMountedImage(0) != WrestlingBeltImage.getID())
			return;

		if (getSimTime() - %obj.lastWrestlingAction < %obj.nextWrestlingCooldown)
			return;

		if (%slot == 0) // LeftClick
		{
			if (%state)
			{
				%obj.playThread(2, "shiftUp");
				if (isObject(%obj.heldPlayer))
				{
					%obj.playThread(2, "shiftUp");
					%target = %obj.heldPlayer;
					%obj.mountObject(%target, 8);
					%target.dismount();

					%origin = %obj.getPosition();
					%vector = %obj.getEyeVector();
					%position = vectorAdd(%origin, vectorScale(%obj.getForwardVector(), 2));
					%velocity = vectorAdd(%obj.getVelocity(), vectorScale(%vector, 5));
					%ray = containerRayCast(%origin, %position, $TypeMasks::FxBrickObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::StaticShapeObjectType); //No stuckination in bricks or terrain pls
					if (%ray !$= 0) {
						%position = %origin;
						%velocity = "0 0 0";
					}

					%target.setTransform(%position SPC getWords(%obj.getTransform(), 3, 6));
					%target.setVelocity(%velocity);
					%obj.nextWrestlingCooldown = 500;
					%obj.lastWrestlingAction = getSimTime();
					serverPlay3d(WrestlingSwooshSound, %obj.getHackPosition());
				}
				else
				{
					%a = %obj.getEyePoint();
					%b = vectorAdd(%a, vectorScale(%obj.getEyeVector(), 4));
					%mask = $TypeMasks::All ^ $TypeMasks::FxBrickAlwaysObjectType;

					%ray = containerRayCast(%a, %b, %mask, %obj);
					if (isObject(%ray) && %ray.getType() & $TypeMasks::playerObjectType && miniGameCanDamage(%obj,%ray) == 1)
					{
						%obj.grabDoAfter(%ray);
						%obj.lastWrestlingAction = getSimTime();
					}
				}
			}
			else
			{
				if (isEventPending(%obj.grabDoAfter))
				{
					if (isObject(%obj.client))
						%obj.client.centerPrint("Grab failed!", 2);
					cancel(%obj.grabDoAfter);
				}
			}
		}
		else if (%slot == 4) // RightClick
		{
			if (%state)
			{
				if (isObject(%obj.heldPlayer))
				{
					%faceUpDown = getWord(%obj.getEyeVector(), 2);
					if (%faceUpDown > 0.7)
					{
						%obj.playThread(0, "plant");
						%obj.playThread(1, "plant");
						%obj.schedule(200, WrestlingSuplex);
					}
					else if (%faceUpDown < -0.7)
					{
						%obj.playThread(0, "jump");
						%obj.playThread(1, "jump");
						%obj.playThread(3, "shiftUp");
						%obj.schedule(200, WrestlingGroundSlam);
					}
					else
					{
						%obj.playThread(0, "jump");
						%obj.playThread(1, "jump");
						%obj.playThread(3, "shiftUp");
						%obj.schedule(100, WrestlingBackBreaker);
					}
				}
				else
				{
					%obj.playThread(2, "activate2");
					%a = %obj.getEyePoint();
					%b = vectorAdd(%a, vectorScale(%obj.getEyeVector(), 4));
					%mask = $TypeMasks::All ^ $TypeMasks::FxBrickAlwaysObjectType;

					%ray = containerRayCast(%a, %b, %mask, %obj);
					if (isObject(%ray) && %ray.getType() & $TypeMasks::playerObjectType && miniGameCanDamage(%obj,%ray) == 1)
					{
						serverPlay3d(WrestlingPushSound, %ray.getHackPosition());
						// %vel = vectorScale(%obj.getForwardVector(), 10);
						%vel = vectorAdd(%vel, "0 0 5");
						%ray.setTransform(getWords(%ray.getTransform(), 0, 2) SPC getWords(%obj.getTransform(), 3, 6));
						%ray.setVelocity(%vel);
						%obj.nextWrestlingCooldown = 500;
					}
				}
				%obj.lastWrestlingAction = getSimTime();
			}
			// else
			// {
			// }
		}
		else if (%slot == 2) // Jump
		{
			if (%state)
			{
				// if (isObject(%obj.heldPlayer))
				// {
				// 	%faceUpDown = getWord(%obj.getEyeVector(), 2);
				// 	if (%faceUpDown > 0.5)
				// 	{
				// 		talk("SUPLEX!");
				// 	}
				// 	else if (%faceUpDown < -0.5)
				// 	{
				// 		talk("DOWN SLAM!");
				// 	}
				// 	else
				// 	{
				// 		talk("FORWARD TOSS!");
				// 	}
				// }
			}
		}
	}
};

activatePackage("WrestlingBeltPackage");
